import greenfoot.*;
import java.lang.Math;

public class Test extends World
{
    private final int LENGHT_TANGENT = 1000;
    private final int LENGHT_IMPACT = 200;
    
    private int angle_tangent = 0;
    private int angle_impact = 0;
    
    private double x_tangent_off,y_tangent_off;
    private double x_impact_off,y_impact_off;
    private double x_rebound_off,y_rebound_off;

    public Test()
    {
        super(700, 700, 1);
        
        ComputeTangentOff();
        DrawTangent();
        ComputeImpactOff();
        DrawImpact();
        Rebound();
    }
    
    public void act()
    {
        if(Greenfoot.isKeyDown("up") || Greenfoot.isKeyDown("down"))
        {
            DeleteTangent();
            if(Greenfoot.isKeyDown("up"))angle_tangent++;
            if(Greenfoot.isKeyDown("down"))angle_tangent--;
            ComputeTangentOff();
            DrawTangent();
            DrawImpact();
            Rebound();
        }
        
        if(Greenfoot.isKeyDown("left") || Greenfoot.isKeyDown("right"))
        {
            DeleteImpact();
            if(Greenfoot.isKeyDown("left"))angle_impact++;
            if(Greenfoot.isKeyDown("right"))angle_impact--;
            ComputeImpactOff();
            DrawTangent();
            DrawImpact();
            Rebound();
        }
    }
    
    private void DeleteTangent()
    {
        getBackground().setColor(Color.WHITE);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_tangent_off),(int)(getBackground().getHeight() / 2 - y_tangent_off),(int)(getBackground().getWidth() / 2 + x_tangent_off),(int)(getBackground().getHeight() / 2 + y_tangent_off));
    }
    
    private void DrawTangent()
    {
        getBackground().setColor(Color.BLACK);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_tangent_off),(int)(getBackground().getHeight() / 2 - y_tangent_off),(int)(getBackground().getWidth() / 2 + x_tangent_off),(int)(getBackground().getHeight() / 2 + y_tangent_off));
    }
    
    private void ComputeTangentOff()
    {
        x_tangent_off = Math.cos(Math.toRadians(angle_tangent)) * (LENGHT_TANGENT / 2);
        y_tangent_off = Math.sin(Math.toRadians(angle_tangent)) * (LENGHT_TANGENT / 2);
    }
    
    private void DeleteImpact()
    {
        getBackground().setColor(Color.WHITE);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_impact_off),(int)(getBackground().getHeight() / 2 - y_impact_off),(int)(getBackground().getWidth() / 2),(int)(getBackground().getHeight() / 2));
    }
    
    private void DrawImpact()
    {
        getBackground().setColor(Color.GREEN);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_impact_off),(int)(getBackground().getHeight() / 2 - y_impact_off),(int)(getBackground().getWidth() / 2),(int)(getBackground().getHeight() / 2));
    }
    
    private void ComputeImpactOff()
    {
        x_impact_off = Math.cos(Math.toRadians(angle_impact)) * LENGHT_IMPACT;
        y_impact_off = Math.sin(Math.toRadians(angle_impact)) * LENGHT_IMPACT;
    }
    
    private void Rebound()
    {
        DeleteRebound();
        
        x_rebound_off = Math.cos(Math.toRadians(180 + angle_tangent - (angle_impact - angle_tangent))) * LENGHT_IMPACT;
        y_rebound_off = Math.sin(Math.toRadians(180 + angle_tangent - (angle_impact - angle_tangent))) * LENGHT_IMPACT;
        
        DrawRebound();
    }
    
    private void DeleteRebound()
    {
        getBackground().setColor(Color.WHITE);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_rebound_off),(int)(getBackground().getHeight() / 2 - y_rebound_off),(int)(getBackground().getWidth() / 2),(int)(getBackground().getHeight() / 2));
    }
    
    private void DrawRebound()
    {
        getBackground().setColor(Color.RED);
        getBackground().drawLine((int)(getBackground().getWidth() / 2 - x_rebound_off),(int)(getBackground().getHeight() / 2 - y_rebound_off),(int)(getBackground().getWidth() / 2),(int)(getBackground().getHeight() / 2));
    }
}